"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
window["StatsigCodeHelper"] = window["StatsigCodeHelper"] || {
    _CODE_PARAM: 'code',
    _CONSOLE_DEBUG: localStorage.getItem('DEBUG_StatsigCodeHelper'),
    _pendingInjections: [],
    _memoizedExperimentCode: {},
    _addStatsigSdk: function (apiKey, nonce, callback) {
        var script = document.createElement('script');
        if (nonce) {
            script.nonce = nonce;
        }
        script.src = 'https://cdn.jsdelivr.net/npm/statsig-js';
        script.addEventListener('load', callback);
        document.head.appendChild(script);
    },
    injectDynamicCode: function (experimentId) {
        StatsigCodeHelper._pendingInjections.push(function () { return StatsigCodeHelper._runExperimentCode(experimentId); });
        if (StatsigCodeHelper._sdkInitialized) {
            StatsigCodeHelper._processPendingInjections();
        }
    },
    Utilities: {
        addStyles: function (stylesheetText) {
            var s = document.createElement('style');
            s.innerText = stylesheetText;
            document.head.appendChild(s);
        },
        domReady: function (fn) {
            if (document.readyState !== 'loading') {
                fn();
            }
            else {
                document.addEventListener('DOMContentLoaded', fn);
            }
        },
        windowLoad: function (fn) {
            if (document.readyState === 'complete') {
                fn();
            }
            else {
                window.addEventListener("load", fn);
            }
        },
        observer: (function () {
            var observer, changes = {};
            var applyChange = function (changeElt, cb) {
                observer.disconnect();
                cb(changeElt);
                bindMutationObserver();
            };
            var bindMutationObserver = function (selector) {
                // Create an observer instance to execute when mutations are observed
                observer = new MutationObserver(function (mutationsList) {
                    var selectorList = Object.keys(changes);
                    mutationsList.forEach(function (mutation) {
                        selectorList.forEach(function (selector) {
                            if (mutation.target && mutation.target.matches && mutation.target.matches(selector)) {
                                applyChange(mutation.target, changes[selector]);
                            }
                            else if (mutation.target && mutation.target.nodeName !== '#text') {
                                var mutationTargetChild = mutation.target.querySelectorAll(selector);
                                mutationTargetChild.forEach(function (childEltMutated) {
                                    applyChange(childEltMutated, changes[selector]);
                                });
                            }
                        });
                    });
                });
                observer.observe(document.documentElement, {
                    // attributes: true,
                    // attributeOldValue: true,
                    characterData: true,
                    childList: true,
                    subtree: true,
                    characterDataOldValue: false
                });
            };
            var watch = function (selector, cb) {
                changes[selector] = cb;
                if (!observer)
                    bindMutationObserver();
                // apply changes if elements already exist
                StatsigCodeHelper.Utilities.domReady(function () {
                    document.querySelectorAll(selector).forEach(function (existingElt) {
                        applyChange(existingElt, cb);
                    });
                });
            };
            return watch;
        })()
    },
    _processPendingInjections: function () {
        while (StatsigCodeHelper._pendingInjections.length) {
            var lambda = StatsigCodeHelper._pendingInjections.pop();
            if (lambda) {
                lambda();
            }
        }
    },
    /**
     * Will only log an exposure on the first call
     * For subsequent calls, it will just run the variation code in memory
     */
    _runExperimentCode: function (experimentId) {
        if (StatsigCodeHelper._memoizedExperimentCode[experimentId]) {
            return StatsigCodeHelper._evalString(StatsigCodeHelper._memoizedExperimentCode[experimentId]);
        }
        var config = statsig.getExperiment(experimentId);
        var code = config.get(StatsigCodeHelper._CODE_PARAM, null);
        if (!code) {
            var codeConfig = config.get('codeConfig', null);
            var codeKey = config.get('codeKey', null);
            if (codeConfig && codeKey) {
                var codeDynamicConfig = statsig.getConfig(codeConfig);
                if (codeDynamicConfig) {
                    code = codeDynamicConfig.get(codeKey, null);
                }
            }
        }
        StatsigCodeHelper._memoizedExperimentCode[experimentId] = code;
        return StatsigCodeHelper._evalString(code);
    },
    _evalString: function (jsString) {
        var returnVal;
        try {
            returnVal = eval(jsString);
        }
        catch (err) {
            // Too noisy: StatsigCodeHelper._CONSOLE_DEBUG && console.log(`Error running ${jsString}`, err);
        }
        return returnVal;
    },
    _awaitTriggersDoCallback: function (triggers, callback, experimentKey) {
        var iterableTriggers = Object.entries(triggers), allTriggerPromises = [];
        if (!iterableTriggers.length) {
            StatsigCodeHelper._CONSOLE_DEBUG && console.log("[Statsig Exp \"".concat(experimentKey, "\"] No triggers, activating..."));
            callback();
            return;
        }
        var _loop_1 = function (triggerType, triggerCondition) {
            if (triggerType === 'element_exists') {
                var settings_1 = {
                    selector: typeof triggerCondition === 'object' ? triggerCondition.selector : triggerCondition,
                    continuous: typeof triggerCondition === 'object' ? triggerCondition.continuous : false
                };
                allTriggerPromises.push(new Promise(function (resolve, reject) {
                    StatsigCodeHelper.Utilities.observer(settings_1.selector, function (elt) {
                        if (elt.dataset.statsigChangeApplied && settings_1.continuous) {
                            // invoking callback when using {observe: true}
                            callback();
                        }
                        else if (!elt.dataset.statsigChangeApplied) {
                            // the first detection of this select will get here
                            elt.dataset.statsigChangeApplied = true;
                            resolve();
                        }
                    });
                }));
            }
            else if (triggerType === 'interval_condition') {
                allTriggerPromises.push(new Promise(function (resolve, reject) {
                    StatsigCodeHelper._intervalUntilTrueOrTimeout(function () {
                        return !!StatsigCodeHelper._evalString(triggerCondition.js);
                    }, parseInt(triggerCondition.js) || 5000).then(function () {
                        StatsigCodeHelper._CONSOLE_DEBUG && console.log("[Statsig Exp \"".concat(experimentKey, "\"] Met interval_condition ").concat(JSON.stringify(triggerCondition)));
                        resolve();
                    });
                }));
            }
            else if (triggerType === 'pageload_phase') {
                allTriggerPromises.push(new Promise(function (resolve, reject) {
                    if (triggerCondition === 'dom_ready') {
                        StatsigCodeHelper.Utilities.domReady(resolve);
                    }
                    else if (triggerCondition === 'window_onload') {
                        StatsigCodeHelper.Utilities.windowLoad(resolve);
                    }
                    else {
                        StatsigCodeHelper._CONSOLE_DEBUG && console.log("[Statsig Exp \"".concat(experimentKey, "\"] Invalid ").concat(pageload_phase, ". Value must be dom_ready or window_onload. Test will not activate."));
                    }
                }));
            }
            else {
                // if there's an entry in the triggers array 
                StatsigCodeHelper._CONSOLE_DEBUG && console.log("[Statsig Exp \"".concat(experimentKey, "\"] Unknown condition: '").concat(triggerType, "' = '").concat(triggerCondition, "'"));
            }
        };
        for (var _i = 0, iterableTriggers_1 = iterableTriggers; _i < iterableTriggers_1.length; _i++) {
            var _a = iterableTriggers_1[_i], triggerType = _a[0], triggerCondition = _a[1];
            _loop_1(triggerType, triggerCondition);
        }
        // only attempt to activate if all triggers were added to pending promises array
        if (allTriggerPromises.length === iterableTriggers.length) {
            Promise.all(allTriggerPromises).then(callback);
        }
        else {
            StatsigCodeHelper._CONSOLE_DEBUG && console.log("[Statsig Exp \"".concat(experimentKey, "\"] Skipping activation because of unknown triggers"));
        }
    },
    _intervalUntilTrueOrTimeout: function (checkFcn, timeout) {
        if (checkFcn())
            return Promise.resolve();
        var stepMS = 50, runningForMS = 0;
        return new Promise(function (resolve, reject) {
            var interval = setInterval(function () {
                if (checkFcn()) {
                    resolve();
                    clearInterval(interval);
                }
                runningForMS += stepMS;
                if (runningForMS >= timeout)
                    clearInterval(interval);
            }, stepMS);
        });
    },
    _attemptWebTests: function (configKey) {
        return __awaiter(this, void 0, void 0, function () {
            var webConfig, webExperiments, utilFncString, _loop_2, _i, webExperiments_1, experiment;
            return __generator(this, function (_a) {
                webConfig = statsig.getConfig(configKey);
                webExperiments = webConfig.get('experiments', []);
                utilFncString = webConfig.get('util', '');
                _loop_2 = function (experiment) {
                    var key = experiment.key, _b = experiment.triggers, triggers = _b === void 0 ? {} : _b, url = experiment.url;
                    // check url before the triggers
                    if (url && !window.location.pathname.match(new RegExp(url))) {
                        console.log("[Statsig Exp \"".concat(key, "\"] URL condition not met (").concat(url, "), skipping..."));
                        return "continue";
                    }
                    console.log("[Statsig Exp \"".concat(key, "\"] URL condition met (").concat(url, "), evaluating triggers..."), triggers);
                    StatsigCodeHelper._awaitTriggersDoCallback(triggers, function () {
                        StatsigCodeHelper._CONSOLE_DEBUG && console.log("[Statsig Exp \"".concat(key, "\"] Running variation code"));
                        StatsigCodeHelper._runExperimentCode(key);
                    }, key);
                };
                for (_i = 0, webExperiments_1 = webExperiments; _i < webExperiments_1.length; _i++) {
                    experiment = webExperiments_1[_i];
                    _loop_2(experiment);
                }
                return [2 /*return*/];
            });
        });
    },
    _initializeSDKAndAttemptWebTests: function (apiKey, configKey) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!window['statsig']) {
                            return [2 /*return*/];
                        }
                        if (!!window.statsig.instance) return [3 /*break*/, 2];
                        return [4 /*yield*/, statsig.initialize(apiKey, {})];
                    case 1:
                        _a.sent();
                        StatsigCodeHelper._sdkInitialized = true;
                        StatsigCodeHelper._processPendingInjections();
                        StatsigCodeHelper._attemptWebTests(configKey);
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    },
};
if (document.currentScript && document.currentScript.src) {
    var url = new URL(document.currentScript.src);
    var apiKey_1 = url.searchParams.get('apikey'), configKey_1 = url.searchParams.get('configkey');
    if (apiKey_1 && configKey_1) {
        StatsigCodeHelper._addStatsigSdk(apiKey_1, document.currentScript.nonce, function () {
            StatsigCodeHelper._initializeSDKAndAttemptWebTests(apiKey_1, configKey_1);
        });
    }
}
